# Shakti Secure Boot Framework

## Motivation
The recent Operating Systems and Antivirus Softwares have considerably hardened the code and limited the attack vectors possible. This has lead to increased attacks on the BIOS/bootloading software as there is no Kernel or any antivirus software running at that point in the boot process to protect the system. A malware which mounts this kind of attack is termed *bootkit* or *rootkit*. These malwares are virtually untraceable by the system unless a search targetting such code in the firmware is mounted. These malware inject exploit code into the system by either patching or replacing the firmware or by modifying the code where the firmware hands over control to the operating system. Compromising the system at the early stages of the boot is one of the easiest ways of gaining control of the system. Such exploits can access high privilege levels and can evade the security policies enforced by the Operating System. 

Secure boot aims to protect the system during boot by detecting and preventing execution of modified firmware/bootloaders or unsigned boot programs, thereby preventing any malware from taking control of the system at early boot stages. The secure boot framework is primarily aimed at mitigating bootkit and rootkit attacks, but it can also be used to prevent any unauthorised firmware to be run on the device. The same concepts can also be used at higher level of program abstractions for providing same guarentees.

The following code/tools are offered as part of the framework - 
* SHABlib (Shakti High Assurance Boot Library)
* CST (Code Signing Tool)
* ZSBL(Zero Stage Boot Loader)


## Threat Model and Security Guarantees
The threat model assumes that the first program that gets loaded/executed (after the Boot ROM code) is tampered by an attacker. The solution guarantees that this tampered program will not be executed by the processor. This first program could be either an embedded standalone program (that does not in turn load any other program), or a first stage bootloader (FSBL) that in turn loads another bootloader, or an image. Any bugs in the first stage, or any other levels of bootloader, is not a part of the threat model. This framework also assumes that if the kernel, hypervisor, or the operating system wants to verify the signature of other programs that it want's to load, which have been signed using a new key, they should maintain their own public key store table.

The threat model also guarentees prevention of execution of any unsigned program at any level of software, provided all the software in the below levels guarantee that no program can be loaded without calling a "verify" functions. This also assumes that the "verify" functions is implicitly trusted, and does not have any bugs.

The Boot ROM code is implicitly trusted. Bugs in the software, like buffer overflow, at any level of program abstraction can lead to malicious operations are not a part of the threat model.

## Signing Process
To first understand the basic concept of signing, consider that there exists a public private key pair where Kr is the private key and Ku is the public key. In order to verify the authenticity of a program P, the checksum of P is computed (using SHA256) and this checksum is encrypted using Kr. Let this signature be Sr. This operation is done on the host system as a part of prepping the executable. The program P, along with the signature Sr is now given to the processor. The processor computes the checksum (say, C1) of the program and also decrypts Sr. It then matches this decrypted value with C1 and checks if they are equal. The equality implies that neither the program, nor the checksum has been tampered with.
The above mentioned process is an overview of the general technique, but the actual technique has some more steps for a much more flexible solution. To understand the complete solution, we first describe some of the terms/concepts used.

## PKI Tree
For a flexible solution where multiple keys need to be used, it is important to maintain these keys and ensure their authenticity. To facilitate the same, we use a key structure is known as a PKI(Public Key Infrastructure) tree. Every key is signed by its parent, except for the root key(which is self-signed). A sample PKI tree is shown below.

![Sample PKI Tree](pki.png)

## Command Sequence File (CSF)
The CSF is generated by the Code Signing Tool (CST) which indicates the various operations that need to be performed when verifying the authenticity of a signed program.

After compilation of the binary file, the *cst*(Code Signing Tool) is used to create the binary *csf* file for the image. The tool generates the necessary data for authentication of the image and places it in a custom section in the elf. This data is used at runtime to ensure the authenticity of the image. 

## Code Signing Tool (CST)
The CST performs the following operations:

* Generate and manage the PKI tree - The *cst* can use pre-generated keys by any tools like *openssl* or generate keys by itself. The configurations are controlled by files and easy to use.
* Generates csf - The *cst* takes in an ini file as input and based on the specified commands, generates the binary equivalent to be used in the boot process. Currently the *cst* can work on outputs generated by *elf2hex* and write out to a raw binary file or modify an elf with the csf as a note section with the Allocate flag set/unset.
## Authentication Flow
The images are verified using a data structure called the *csf*. The *csf* contains the commands which specify which key to install, the location of the signature to verify against and other necessary information. This file is parsed by the library to perform the authentication of the associated image. 

![Authentication Flow for First Image in Boot Chain](authimage1.png)

![Authentication Flow for other Images](authimage2.png)

### SRK Installation
The csf for first image to be loaded provides the SRK Table and specifies the index of the key to install. Only one SRK is allowed to be installed in a particular boot flow. The root of trust is established using programmable e-fuses. These fuses store the hash value of the SRK Table. The hash of the table is calculated and compared with the stored hash. If they match, then the key at the specified index is installed onto the public key store. 

Three single bit fuses are provided to allow for revocation of the SRKs. Only SRKs present at index 0 to n-1(where n is the total number of SRKs) in the table can be revoked. Incase of a compromised SRK, the corresponding fuse can be blown and an installation is successful during the boot only if the corresponding revocation fuse has not been blown. 

NOTE: The final SRK can not be revoked at any point so as to prevent accidental bricking of the device. 

### SignKey Installation
The signature of the certificate containing the key is verified using the pre-installed SRK. If the signature matches, the key is installed onto the public key store. Currently there is no provision for revocation of such keys.

### Image Signature Authentication
A hash of the *csf* as well as the specified bytes in the image is calculated individually and the hash of the concatenated values calculated is authenticated against the value calculated offline.

The objective is to prevent any unauthorised code from running before the Operating system is in place to enforce permissions. This is enforced by ensuring that the FSBL(first stage bootloader) is signed and hence the bootloader can be trusted. The bootloaders in the boot chain are modified such that each stage verifies the next stage using the library in the boot rom before launching it. By ensuring this, any untrusted/modified code can be recognised and execution of such code can be prevented. 

